// knk_args.cpp

#include <knk_args.h>
#include <unistd.h>
//#include "unistd.h"  // getopt
#include <njs_io.h>
#undef NJS_DEBUG

using namespace Knk;
using namespace Njs;

string args::command = "nextpeak";
char* args::genomicfile = NULL;
char* args::seqlenfile = NULL;
char* args::chipseqfile = NULL;
char* args::mappabilitydir = NULL;
char* args::regionOutFile = NULL;
char* args::anchoredCntFile = NULL;
char* args::motifLocFile = NULL;
char* args::simdatafile =NULL;
long args::winSize = 150;
long args::minTagNum = 15;
double args::beta = 50; //65;
double args::sigma = 30;// 40;
long args::tagLen = 25;
long args::motifLen = 15;
long args::tabVecLen = 1000;
bool args::find2ndPeaks = false;
long args::distMotSite = 250;
bool args::useBIC = true;

void args::parse(int argc, char **argv)
{
  int c;
  for (int i = 1; i < argc; ++i) {
    command += string(" ") + argv[i];
  }
	try
	{
		if(argc < 2) throw 0;
	}
	catch(int err_)
	{
		cout << setprecision(2) << "Input error\n see README file" << endl;
		exit(0);
	}

	while ((c = getopt(argc, argv, "g:l:c:w:t:d:r:b:s:a:b:m:v:h:i:2ye:9:")) != -1)
    switch (c) {
      case '2':
	find2ndPeaks = true;
	break;
      case 'e':
	distMotSite = atoi(optarg);
	break;
      case '9':
	simdatafile = optarg;
	break;
      case 'y':
	useBIC = true;
      case 'g':
	genomicfile = optarg;
	break;
      case 'l':
	seqlenfile = optarg;
	break;
      case 'c':
	chipseqfile = optarg;
	break;
      case 'd':
	mappabilitydir = optarg;
	break;
      case 'r':
	regionOutFile = optarg;
	break;
      case 'a':
	anchoredCntFile = optarg;
	break;
      case 'm':
	motifLocFile = optarg;
	break;
      case 'b':
	beta = atof(optarg);
	break;
      case 's':
	sigma = atof(optarg);
	break;
      case 'w':
	winSize = atoi(optarg);
	break;	
      case 't':
	minTagNum = atoi(optarg);
	break;
      case 'h':
	tagLen = atoi(optarg);
	break;	
      case 'i':
	motifLen = atoi(optarg);
	break;
      case 'v':
	tabVecLen = atoi(optarg);
	break;

    case '?':
      cout << "See README file"  << endl;  // "invalid option" message is printed by getopt
    }
}
